#!/bin/bash


for i in geom*.wfn
do 

  echo $i 
  sed "s/tmp.wfn/${i}/g" elf.inp > ${i}_elf.inp
  sed "s/tmp.wfn/${i}/g" rho.inp > ${i}_rho.inp
  sed "s/tmp.wfn/${i}/g" grid.inp >${i}_grid.inp
  sed "s/tmp.wfn/${i}/g" pop.inp > ${i}_pop.inp
  sed "s/tmp.sbf/${i%%.*}_ebas.sbf/g" ebas_sbf.inp > ${i}_ebas_sbf.inp 
  sed  -e "s/tmp_ebas.sbf/${i%%.*}_ebas.sbf/g" -e "s/tmp_ebas.xyz/${i%%.*}_ebas.xyz/g" exyz.inp > ${i}_exyz.inp
  sed  -e "s/tmp.wfn/${i}/g" -e "s/tmp.sbf/${i%%.*}_esyn.sbf/g" ysbf.inp > ${i}_ysbf.inp
  sed  -e "s/tmp.wfn/${i}/g" -e "s/tmp.sbf/${i%%.*}_elf.sbf/g" esbf.inp > ${i}_esbf.inp
  sed  -e "s/save/${i}/g" -e "s/sub/elf_$i/g" sub_elf_2.save > sub_elf_$i
  qsub sub_elf_$i
  
done

