      implicit none
      integer i, j, n, k, l, lstart, lend, n1,nts,nirc,n2, natoms
      integer nsave,nlth,icharge,imult,lfile,iend,isave,iunit
      integer npts,k1,k2
      integer, dimension (:), allocatable :: nat
      double precision, dimension (:), allocatable :: r,ener
      double precision, dimension (:,:), allocatable :: x,y,z
      double precision emin,emax
      character*40 dummy
      character (len=80), dimension (:), allocatable :: line
      character (len=45) :: filein,fileirc,filegeom
      character (len=1), dimension(80) :: cline
      character (len=1) :: blank
      character (len=2) char_route,delimit
      character (len=7) char_charge
      character (len=10) char_scf
      character (len=11) format_scf
      character (len=42) char_ircpt
      character (len=28) char_path
      character (len=46) char_natoms,char_geom
      character (len=43) char_ircval
      character (len=42) char_summary
      logical locate,located,irc_summary
      CHARACTER*80 previous, current, nothing,titre
      character*8 fig_file,g03c2
      character*9 g03c3
      character*16 g03c1
      character (len=1), dimension(80) :: g03route
      data blank/' '/
      COMMON /locate_last/ previous,current
      char_scf=' SCF Done:'
      char_geom='                          Input orientation:'
      char_ircpt=' Trajectory Number     1    Step Number   '
      char_ircval='   NET REACTION COORDINATE UP TO THIS POINT'
      char_summary='                  Summary of reaction path'
      char_path='  # OF POINTS ALONG THE PATH'
      char_route=' #'
      char_natoms='                          Input orientation:'
      delimit=' -'
      char_charge=' Charge'
      g03c1='%mem=250Mb,45000'
      g03c2='%nosave '
      g03c3='--Link1--'
      Call GETARG(1,filein)
c     filein='ircr.log'
      DO I=1,len_trim(filein)
         IF (filein(i:i).eq.'.') nlth=I-1
      ENDDO
      IF (nlth.LE.1) STOP 'Wrong filename... l55  aborting!'
      iunit=1
      open(unit=1,file=filein,status='old')
      write(*,*) ' npts'
      read(*,*) npts
      filegeom='geom_tot.inp'
c     instruction route de gaussian
      i=1
      rewind(unit=1)
      call find_string(char_route,iunit,i)
      isave=i
      backspace(unit=1)
      read(1,"(80a1)") g03route
      g03route(1)=g03route(2)
      g03route(2)=g03route(3)
      i=4
      do while(g03route(i).eq.blank)
         i=i+1
      enddo   
      do while(g03route(i).ne.blank)
         i=i+1
      enddo   
      do j=3,i-1
         g03route(j)=g03route(j+1)
      enddo
      g03route(i)=blank
      g03route(i+1)=blank
      g03route(i+2)='N'
      g03route(i+3)='o'
      g03route(i+4)='s'
      g03route(i+5)='y'
      g03route(i+6)='m'
      g03route(i+7)='m'
      g03route(i+8)=blank
      g03route(i+9)='o'
      g03route(i+10)='u'
      g03route(i+11)='t'
      g03route(i+12)='='
      g03route(i+13)='w'
      g03route(i+14)='f'
      g03route(i+15)='n'
      do j=i+16,80
         g03route(j)=blank
      enddo
c     find charge multiplicity
      i=isave
      call find_string(char_charge,iunit,i)
      isave=i
      backspace(unit=1)
      read(1,"(9x,i3,15x,i2)") icharge,imult
c     find number of atoms
      i=isave
      call find_string(char_natoms,iunit,i)
      isave=i
      do i=1,4
         read(1,"(a80)") current
      enddo
      isave=isave+5
      i=isave
      natoms=0
      call find_string(delimit,iunit,natoms)
c     find geometry, energy and nature of atoms
      allocate(ener(npts),r(npts))
      allocate (nat(natoms))
      allocate (x(npts,natoms),y(npts,natoms),z(npts,natoms))
      rewind (unit=1)
      call find_string(char_geom,iunit,i)      
      do j=1,4
         read(1,"(a80)",iostat=iend) current
      enddo
      do j=1,natoms
         read(1,*,iostat=iend) k,nat(j),k,x(1,j),y(1,j),z(1,j)
         if(iend.ne.0) then
           write(*,*) iend
           stop 'line 195'
         endif
      enddo
      call find_string(char_scf,iunit,i)
      backspace (unit=1)
      read(unit=1,fmt='(80a1)') cline
      k=1
      do while (cline(k).ne.'=')
         k=k+1
      enddo
      k1=k/10
      k2=k-10*k1
      format_scf='('//char(48+k1)//char(48+k2)//'x,f17.9)'
      backspace(unit=1)
      read(unit=1,fmt=format_scf,iostat=iend) ener(1)
      do i=2,npts
         k=0

        call find_string(char_ircpt,iunit,k)
         call revfind_string(char_geom,iunit,k)
         do j=1,5
            backspace(unit=iunit)
         enddo
         k=0
         call find_string(char_geom,iunit,k)
         do j=1,4
            read(1,"(a80)",iostat=iend) current
         enddo
         do j=1,natoms
            read(1,*,iostat=iend) k,nat(j),k,x(i,j),y(i,j)
     &                            ,z(i,j)
            if(iend.ne.0) then
               write(*,*) iend,j
               stop 'line 215'
            endif
         enddo
         call find_string(char_scf,iunit,k)
         backspace(unit=1)
         read(unit=1,fmt='(80a1)') cline
         k=1
         do while (cline(k).ne.'=')
            k=k+1
         enddo
         k1=k/10
         k2=k-10*k1
         format_scf='('//char(48+k1)//char(48+k2)//'x,f17.9)'
         backspace(unit=1)
         read(unit=1,fmt=format_scf,iostat=iend) ener(i)
         located=.true.
         do while(located)
            read(1,"(a80)",iostat=iend) current
            if(char_ircpt(1:42).eq.current(1:42)) then
               located=.false.
               locate=.false.
            endif
            if(iend.ne.0) then
              located=.false.
              write(*,*) 'string not found',iend
            endif
         enddo
      enddo
      close(unit=1)
      close(unit=2)
c     write input 
      if(n1.lt.0) n1=0
      open(unit=3,file=filegeom,status='unknown')
      write(*,*) ' create geoms.inp'
      do i=1,npts
         nirc=npts-i+1
         write(3,'(a16)') g03c1
         write(3,'(a8)') g03c2
         write(3,'(80a1)') g03route
         write(3,*) '                          '
         if(r(1).lt.r(npts)) then
            k=i+n1
         else
            k=npts+n1+1-i
         endif
         if(k.lt.10) then
            write(3,'(a6,i1,4x,a2,f12.6,2x,a2,f12.6)') 'geom00',k,
     .            'E=',ener(nirc)
         else if (k.lt.100) then
            write(3,'(a5,i2,4x,a2,f12.6,2x,a2,f12.6)') 'geom0',k,
     .            'E=',ener(nirc)
         else
            write(3,'(a4,i3,4x,a2,f12.6,2x,a2,f12.6)') 'geom',k,
     .            'E=',ener(nirc)
         endif
         write(3,*) '                          '
         write(3,'(2i4)') icharge,imult
         do j=1,natoms
             write(3,'(i4,3f12.6)')nat(j),x(nirc,j),y(nirc,j),z(nirc,j)
         enddo
         write(3,*) '                          '
         if(k.lt.10) then
            write(3,'(a6,i1,a4)') 'geom00',k,'.wfn'
         else if (k.lt.100) then
            write(3,'(a5,i2,a4)') 'geom0',k,'.wfn'
         else
            write(3,'(a4,i3,a4)') 'geom',k,'.wfn'
         endif
         if(nirc.lt.npts) then
            write(3,'(a9)') g03c3
         endif
      enddo
      close(unit=3)
      end   
      subroutine find_string(string,iunit,i)
      logical located
      integer iunit,iend,lg,j,k
      character (len=30) format_scf
      character*(*) string
      character (len=80) current
      located=.true.
      lg=len(string)
      if(lg.lt.10) then
      format_scf='("string not found ",i3,2x,a'//char(48+lg)//')'
      else
         j=lg/10
         k=lg-10*i
         format_scf='("string not found",i3,2x,a'//char(48+j)//
     .                 char(48+k)//')'
      endif
      do while(located)
         read(iunit,"(a80)",iostat=iend) current
         if(string(1:lg).eq.current(1:lg)) then
            located=.false.
         else
            i=i+1
         endif
         if(iend.ne.0) then
           located=.false.
           write(*,format_scf) iend,string
         endif
      enddo
      return
      end
      subroutine revfind_string(string,iunit,i)
      logical located
      integer iunit,iend,lg,j,k
      character (len=30) format_scf
      character*(*) string
      character (len=80) current
      located=.true.
      lg=len(string)
      if(lg.lt.10) then
      format_scf='("string not found ",i3,2x,a'//char(48+lg)//')'
      else
         j=lg/10
         k=lg-10*i
         format_scf='("string not found",i3,2x,a'//char(48+j)//
     .                 char(48+k)//')'
      endif
      do while(located)
         backspace(unit=iunit)
         read(iunit,"(a80)",iostat=iend) current
         backspace(unit=iunit)
         if(string(1:lg).eq.current(1:lg)) then
            located=.false.
         else
            i=i+1
         endif
         if(iend.ne.0) then
           located=.false.
           write(*,format_scf) iend,string
         endif
      enddo
      return
      end
