#!/bin/bash


for i in geom*.wfn
do 

  echo $i 
  sed "s/ts_r.wfn/${i}/g" nci.inp > ${i}_nci.inp
  sed -e "s/save/${i}_nci/g" -e "s/nci_ts/nci_$i/g" sub_nci.save > sub_nci_$i
  qsub sub_nci_$i

done

for i in geom*.wfn
do

  until  [ -e ${i%%.*}"-dens.cube" ]  
    do
      echo "Waiting for "${i%%.*}"-dens.cube";
      sleep 300;
    done
  rm *.o1* ${i}_nci.inp sub_nci_${i}
done

