#!/bin/bash



for i in geom*.wfn
do

  echo $i
  sed  -e "s/tmp.wfn/${i}/g" -e  "s/tmp-dens.cube/${i%%.*}-dens.cube/g" -e  "s/tmp-grad.cube/${i%%.*}-grad.cube/g" -e  "s/tmp.dat/${i%%.*}.dat/g" topo.inp > ${i}_topo.inp
  sed -e "s/tmp_topo/${i%%.*}_topo/g" -e "s/sub/topo_$i/g" sub_toponci.save > sub_toponci_$i
  qsub sub_toponci_$i

done

for i in geom*.wfn
do

  until  [ -e ${i%%.*}"_topo.xyz" ]  
    do
      echo "Waiting for "${i%%.*}"_topo.xyz";
      sleep 120;
    done
  rm *.o1* ${i}_topo.inp sub_toponci_${i}
done

